VERSION 5.00
Begin VB.Form frmMem 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Memory dump - page &00xx"
   ClientHeight    =   4455
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   8910
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmMem.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4455
   ScaleWidth      =   8910
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton btnNext 
      Caption         =   "&Next page"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   7200
      TabIndex        =   4
      Top             =   120
      Width           =   1575
   End
   Begin VB.CommandButton btnGo 
      Caption         =   "&Go"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3960
      TabIndex        =   3
      Top             =   120
      Width           =   495
   End
   Begin VB.TextBox txtGo 
      Height          =   360
      Left            =   3240
      TabIndex        =   2
      Text            =   "FF00"
      Top             =   140
      Width           =   615
   End
   Begin VB.CommandButton btnPrev 
      Caption         =   "&Previous page"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label lblGo 
      Alignment       =   1  'Right Justify
      BackStyle       =   0  'Transparent
      Caption         =   "Page &&"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   2280
      TabIndex        =   1
      Top             =   200
      Width           =   855
   End
End
Attribute VB_Name = "frmMem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Memory dump window.
'
' Project: FileStore [E01S emulator]
' Module : frmMeme (form)
' Status : Loaded at start, closing window HIDES but doesn't unload.
'
' Version: 0.00
' Date   : 1st July 2009
' Started: 14th June 2009
'
' Author : Rick Murray, heyrick1973 -at- yahoo -dot- co -dot- uk
'          http://www.heyrick.co.uk/econet/
'
'
' Licence:
'
'   Copyright 2010 Rick Murray
'
'   Licensed under the EUPL, Version 1.1 ONLY (the "Licence");
'   You may not use this work except in compliance with the Licence.
'
'   You may obtain a copy of the Licence at:
'
'     http://ec.europa.eu/idabc/eupl5
'
'   Unless required by applicable law or agreed to in writing, software
'   distributed under the Licence is distributed on an "AS IS" basis,
'   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
'   implied. See the Licence for the specific language governing
'   permissions and limitations under the Licence.
'
'
'   Rick's note: The EUPL is "compatible" with GPL v2, but *NOT* the more
'                restrictive GPL v3. If you will be involving GPL code
'                in this project, or using some of this code in a GPL
'                project, you should specify the use of ONLY the GPL v2
'                (and not the boilerplate "GPL 2 or any later...").
'

Option Explicit


Private MemPage As Long
Private MemBuff(0 To 255) As Byte
Private HiRow As Integer, HiCol As Integer
Private SelRow As Integer, SelCol As Integer
Private TxtWid As Single, TxtHei As Single


Private Sub Form_Load()
  Me.Left = (Screen.Width - Me.Width) \ 2
  Me.Top = (Screen.Height - Me.Height) \ 2
  
  Me.txtGo.Text = ""
  
  TxtWid = Me.TextWidth("X")
  TxtHei = Me.TextHeight("X")
  
  HiRow = -1
  HiCol = -1
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, _
                             UnloadMode As Integer)
  If (UnloadMode = vbFormControlMenu) Then
    Me.Hide
    Cancel = 123
  End If
End Sub


Private Sub Form_MouseMove(Button As Integer, Shift As Integer, _
                           X As Single, Y As Single)
  Dim MyX As Single, MyY As Single
  
  DrawHighlight
  
  ' Use "Int" as it simply omits the fractional part.
  ' "CInt" rounds to nearest!
  
  If (X > 900) And (X < 6700) Then
    ' Left hand part
    MyX = ((X - 900#) / (TxtWid * 3#))
    HiCol = Int(MyX)
  ElseIf (X > 6950) Then
    ' Right hand part
    MyX = ((X - 6950) / TxtWid)
    HiCol = Int(MyX)
  Else
    HiCol = -1
  End If
  MyY = ((Y - 620#) / TxtHei)
  HiRow = Int(MyY)
  If (HiRow < -1) Then HiRow = -1
  
  DrawHighlight
End Sub


Private Sub Form_DblClick()
  Dim MyText As String, MyByte As Byte, Reply As String, BVal As String
  
  If (HiCol = -1) Then Exit Sub
  
  On Error GoTo DblClickErr
  
  MyByte = MemBuff((HiRow * 16) + HiCol)
  BVal = Right$("00" & Hex(MyByte), 2)
  MyText = "Change the byte at address &" & Right$("0000" & _
           Hex$((MemPage * 256&) + (HiRow * 16) + HiCol), 4) & _
           " from &" & BVal & " to..." & vbCrLf & vbCrLf & _
           "(please enter a single byte value in HEX)"
  Reply = InputBox(MyText, "Change memory", BVal)
  ' ##TODO## Make this a custom (better looking!) window as vbModal
  If (Len(Reply) = 0) Then Exit Sub
  MyByte = CByte("&H" & Reply)
  
  MemBuff((HiRow * 16) + HiCol) = MyByte
  Memory_Poke ((MemPage * 256&) + (HiRow * 16&) + HiCol), MyByte
    
  Exit Sub

DblClickErr:
  If (Err.Number = 6) Then
    ' Overflow - only a single byte please!
    MsgBox "Overflow error - you can only enter values between " & _
           "&00 and &FF; i.e. that which fits into a single byte.", _
           vbExclamation + vbOKOnly
  
  ElseIf (Err.Number = 13) Then
    ' Type mismatch - that wasn't a valid hex number...
    MsgBox "That wasn't recognised as a valid hex number...", _
           vbExclamation + vbOKOnly
    
  ' else... just do nothing.
  End If
  
  Err.Clear
End Sub


Private Sub btnPrev_Click()
  ' Go to previous page
  MemPage = MemPage - 1&
  If (MemPage < 0&) Then
    MemPage = 0&
  ElseIf (MemPage = &HFC&) Then
    MemPage = &HFB&
  End If
  
  DrawMemPage
End Sub


Private Sub btnGo_Click()
  ' Go to a specific page
  Dim MyAddr As Long
  
  On Error GoTo btnGo_Error
  
  ' check there's input
  If (Len(Me.txtGo.Text) = 0) Then
    MsgBox "No address has been entered...", vbExclamation
    Exit Sub
  End If
  
  MyAddr = CLng("&H" & Me.txtGo.Text)
  
  ' values UNDER 256 will be taken to be a page, like &14 will be
  ' seen as &14xx; while those entries over 255 will be seen as a
  ' whole address, of which only the page is significant...
  
  If (MyAddr < 256&) Then
    MemPage = MyAddr
    Me.txtGo.Text = Right$("00" & Hex$(MemPage), 2) & "00"
  Else
    MyAddr = MyAddr \ 256&
    MemPage = MyAddr
    Me.txtGo.Text = Right$("00" & Hex$(MemPage), 2) & "00"
  End If
  
  If (MemPage = &HFC) Then
    MsgBox "You can't view the contents of page &FCxx as it is " & _
           "masked out for hardware access.", vbExclamation
    MemPage = 0
  End If

  DrawMemPage
  
  Exit Sub

btnGo_Error:
  MsgBox "The value entered is not recognised as an address." & _
         vbCrLf & "Please enter a hex address.", vbExclamation
  Err.Clear
End Sub


Private Sub txtGo_KeyPress(KeyAscii As Integer)
  If (KeyAscii = 13) Then
    KeyAscii = 0
    btnGo_Click
  End If
End Sub


Private Sub btnNext_Click()
  ' Go to next page
  MemPage = MemPage + 1&
  If (MemPage > 255&) Then
    MemPage = 255&
  ElseIf (MemPage = &HFC&) Then
    MemPage = &HFD&
  End If
  
  DrawMemPage
End Sub


Public Sub DrawMemPage()
  Dim Row As Long, Col As Long, Addr As Long, MyByte As Byte

  If (Me.Visible = False) Then Exit Sub

  Me.Cls
  Me.CurrentY = 600

  Memory_ReadPage MemBuff, MemPage

  For Row = 0& To 15&
    Addr = (MemPage * 256&) + (Row * 16&)
    
    Me.Font.Bold = True
    Me.Print "&" & Right$("0000" + Hex(Addr), 4) & " : ";
    Me.Font.Bold = False
    
    For Col = 0& To 15&
      MyByte = MemBuff((Row * 16&) + Col)
      
      Me.Print Right$("00" & Hex$(MyByte), 2) & " ";
    Next
      
    Me.Font.Bold = True
    Me.Print ": ";
    Me.Font.Bold = False
        
    For Col = 0& To 15&
      MyByte = MemBuff((Row * 16&) + Col)
      
      If (MyByte < 32) Then MyByte = 46 ' Ctrl -> '.'
      
      Me.Print Chr$(MyByte);
    Next
    
    Me.Print
  Next
  
  Me.btnPrev.Enabled = Not (MemPage = 0&)
  Me.btnNext.Enabled = Not (MemPage = 255&)
  
  Me.Caption = "Memory dump - page &" & Right$("00" & _
               Hex$(MemPage), 2) & "xx"
               
  DrawHighlight
End Sub


Public Sub GoToAddr(MyAddr As Long)
  ' Go to specific address; expects &XXxx form.
  
  MemPage = MyAddr \ 256&
  
  If (MemPage = &HFC&) Then
    MsgBox "You can't view the contents of page &FCxx as it is " & _
           "masked out for hardware access.", vbExclamation
    MemPage = 0&
  End If
  
  DrawMemPage
End Sub


Public Sub DrawHighlight()
  ' Uses XOR plotting to draw a highlight around the byte under the
  ' mouse pointer.
  Dim Xpos As Single, Ypos As Single
  
  If ((HiCol = -1) Or (HiRow = -1)) Then Exit Sub
  
  Me.DrawMode = vbXorPen
  
  ' Highlight the hex value
  Ypos = 600 + (HiRow * TxtHei)
  Xpos = 900 + (HiCol * (TxtWid * 3))
  
  Me.Line (Xpos, Ypos)-((Xpos + (TxtWid * 3)), _
          (Ypos + TxtHei)), vbRed, B
          ' red will appear as cyan as it is inversed
  
  ' Highlight the ASCII value
  Ypos = 600 + (HiRow * TxtHei)
  Xpos = 6950 + (HiCol * TxtWid)
  
  Me.Line (Xpos, Ypos)-((Xpos + TxtWid), _
          (Ypos + TxtHei)), vbRed, B
  
  Me.DrawMode = vbCopyPen
End Sub

